# Closed Loop Lumped

This a 0D cardiovascular model for the venous and arterial systems based of Korakianitis and Shi's 2006 paper "A concentrated parameter model for the human cardiovascular system including heart valve dynamics and atrioventricular interaction".

The model is implemented in Fortran but supplied with a Python wrapper.

## Notable Changes From Korakianitis and Shi

- Able to supply heart elastance curves based on ECG timings.
- Thermoregulation model adjusts systemic capillary resistance based of core and skin temperature.
- Packaged with an (multi-objective) optimiser to optimise for stroke volume, systolic and diastolic blood pressure, total arterial resistance and total peripheral compliance.
- Able to specify heart volume from age, weight, height and sex.

## Installation

1. Clone this repository:

```sh
git clone git@gitlab.com:abdrysdale/closed_loop_lumped.git
```

2. Build the Fortran library.

```sh
./build.sh lib
```

`build.sh` without any arguments simply builds the Fortran executable, `lib` is used to specify to build the library.

3. Install dependencies.

Dependencies can be found in `shell.nix`, if you use [nix](https://nixos.org/), simply type `nix-shell`.

4. Run the example.

There are example scripts in `scripts/`, run it to test everything works.

```sh
python thermoregulation_example.py
```

### Docker/Singularity run script

1. Clone this repository:

```sh
git clone git@gitlab.com:abdrysdale/closed_loop_lumped.git
```

2. Build the container.

```sh
chmod +x run.sh
./run.sh -b
```

3. Run the code.

There are example scripts in `scripts/` but to test everything works, run the main script:

```sh
./run.sh src/cl0.py
```

alternatively to run the Fortran code directly:

```sh
./run.sh -e ./closed_loop_lumped
```

If you don't wish to use the `run.sh` script, inspect its contents to see the default docker/singularity commands.


## Usage

This module provides the functions:

- `solve_system`
- `solve_system_parallel`
- `load_defaults`
- `load_default_params`

Along with an optimisation class:
- `Optimiser`

`load_defaults` loads the default parameter values in the correct format, if you would like to have a look at default parameters, run the `load_defaults` function.

If a parameter is not specified, it loads the default value.

```python
from src import load_defaults, solve_system

# If a parameter isn't specified, the defaults are loaded.
# Thus method 1 and method 2 have the same result.

# Method 1
params = load_defaults()
sol = solve_system(*params)

# Method 2
sol = solve_system()
```

Single, or multiple, parameters can be changed by passing part or all of the corresponding
parameter dictionary.

```python
sol = solve_system(
    generic_params={'period': 1}, # Cardiac period of 1s (60bpm)
    left_ventricle={'vmin': 20, 'vmax': 150} # Sets the minimum and maximum volume
    thermal_system={'k_dil': 0, 'k_con': 0}, # Disables thermoregulation
    )
```

Heart volume can be specified by height, weight, age and sex
```python
sol = solve_system(
    generic_params={
        'est_h_vol': True,
        'height': 160,  # Height (cm)
        'weight': 80,   # Weight (kg)
        'age': 32,      # Age (years)
        'sex': 1,       # Sex (1 for female, 0 for male)
    }
)
```

Note that setting 'est_h_vol' to 'True' in the above enables the calculation of the heart volume from
height, weight, age and sex. If heart chamber volumes are specified, they will be overwritten by the
estimated heart volume.

For instance:
```python
sol_1 = solve_system(
    generic_params={
        'est_h_vol': True,
        'height': 160,  # Height (cm)
        'weight': 80,   # Weight (kg)
        'age': 32,      # Age (years)
        'sex': 1,       # Sex (1 for female, 0 for male)
    }
    )
    
sol_2 = solve_system(
    generic_params={
        'est_h_vol': True,
        'height': 160,  # Height (cm)
        'weight': 80,   # Weight (kg)
        'age': 32,      # Age (years)
        'sex': 1,       # Sex (1 for female, 0 for male)
    left_ventricle={'vmin': 20, 'vmax': 150} # Sets the minimum and maximum volume
    }
    )

# sol_1 and sol_2 will yield exactly the same result.
```

Some points to consider if using the heart volume estimations:

- The heart volume estimation is based off mostly white Europeans. If data from other ethnicities becomes available I will update the heart volume estimation ASAP.
- The heart volume is typically over estimated as the estimator was tuned for 2D measurements.
- The heart volume estimation is based off healthy participants and will not be accurate for people with heart defects or abnormalities.
- The original data includes no trans people so may not be accurate for trans people.
- Right ventricle volume estimation is not provided and estimated from the other chamber volume estimation.
- For more information on the implementation, see the `update_heart_vol` subroutine in `src/elastance.f90`.
- For more information on the heart volume estimation see https://doi.org/10.1161/CIRCIMAGING.113.000690

`solve_system_parallel` provides a wrapper around the `solve_system` function but launches processes in parallel.

It expects a parameter list as an argument, whereby each item in the list is unpacked to the `solve_system` function, along with a `num_workers` which is the maximum number of processes to use.

As an example:

```python

# Method 1
param_list = [{"thermal_system": {"t_cr": x}} for x in range(34, 41)]
sol_list = solve_system_parallel(param_list)

# Method 2
sol_list = []
for t_cr in range(34, 41):
    sol_list.append(solve_system("thermal_system"={"t_cr": t_cr}))
    
# Methods 1 and 2 are identical in results but method 1 operates in parallel.
```

`load_default_params` provides the default parameters to use for optimisation.

Each parameter to be optimised is provided with a minimum, maximum and initial value.

The `Optimiser`, is used to tune the network to yield certain physiological responses which can be any of:

- Systolic blood pressure (`sbp`).
- Diastolic blood pressure (`dbp`).
- Cardiac Output (`co`).
- Stroke Volume (`sv`).
- Total peripheral resistance (`tpr`).
- Total arterial compliance (`tac`).

Any optimiser included with [nevergrad](https://facebookresearch.github.io/nevergrad/index.html) should work fine.

When using multiple objectives, it is recommended to use a multi-objective optimisation algorithm.
A good choice for this problem is the `TwoPointsDE` algorithm due to the cheap computational cost of the 
solver.

When using a multi-objective optimiser, the Pareto frontier is returned rather than the single best result.

A full example script highlighting this is [scripts/optimisation_from_db_example.py](scripts/optimisation_from_db_example.py)
which performs multi-objective optimisation for each row in a SQLite database.

```python
from src import Optimiser, solve_system

hr = 89         # Heart Rate in BPM

pr = 0.142      # PR interval (s)
qrs = 0.08      # QRS interval (s)
qt = 0.38       # QT interval (s)

core = 37.48    # Core temperature (°C)
core_ref = 36.8 # Reference core temperature (°C)
skin = 24.23    # Skin temperature (°C)
skin_ref = 34.1 # Reference skin temperature (°C)

# These inputs will be fixed for the optimisation.
inputs = {
    'generic_params': {
        'period': 60/hr,
    },
    'ecg': {
        "t1": pr / 3,
        "t2": pr + qrs/2,
        "t3": pr + qrs + 0.75 * (qt - qrs),
        "t4": pr + qt,
    },
    'thermal_system': {
        't_cr': core,
        't_cr_ref': core_ref,
        't_sk': skin,
        't_sk_ref': skin_ref,
    },
}

# These inputs will be allowed to change for the optimisation.
params = {
    "generic_params": {
        "r_scale": [0.1, 10, 1],
        "c_scale": [0.1, 10, 1],
        'e_scale': [0.25, 4, 1],
    },
    "thermal_system": {
        "k_dil": [37, 113, 75],
        "k_con": [0.25, 0.75, 0.5],
    },
}

# Sets up the optimiser
opt = Optimiser(
    optimiser="TwoPointsDE",
    inputs=inputs,
    params=params,
    budget=1000,
    num_workers=16,
    multi_objective=True,   # This flag is really important!
    tol=1e-3,
    pbar=True,              # This shows a progress bar for the optimisation.
    pbar_pos=1,             # The position of the progress bar can be specified with this option.
)

# Runs the optimiser optimising for stroke volume, diastolic blood pressure and systolic blood pressure
best_params = opt.run(sbp=133, dbp=67, sv=49)

# best_params will be a list of the input parameters on the Pareto frontier.
print(best_params)

# This can also be accessed with:
print(opt.flat_inputs_raw)  # For a list of flattened dictionaries.
print(opt.recommendation)   # For a list of nested dictionaries.
```

```python
from src import Optimiser, solve_system

opt = Optimiser(
    optimiser="NGOpt", # Nevergrad optimiser string
    inputs={"thermal_system": {"t_cr": 38}}, # Inputs passed to the solver.
    params={"thermal_system": {"k_con": [0.25, 0.75, 0.5]}}, # [lower, upper, initial] parameter values
    pbar=True, # Displays a progress bar
    tol=1e-3, # Tolerance for early stopping
    budget=100, # These keyword arguments are passed directly to the optimiser
    num_workers=16, # Specifying num_workers > 1 automatically enables parallelisation
)

best_inputs = opt.run(
    sbp=120,    # Systolic blood pressure (mmHg)
    dbp=80,     # Diastolic blood pressure (mmHg)
    co=4,       # Cardiac Output (L/min)
    sv=60,      # Stroke volume (mL)
)
# As tpr and tac are not specified, they won't be used in the optimisation.
# A minimum of 1 metric is needed for optimisation.

# To get the optimised solution, run
sol = solve_system(**best_inputs)
```

### Default Values

#### load_defaults

The parameters are split into 13 sections, each with its own dictionary.
These are:

- `"generic_params"`
- `"ecg"`
- `"left_ventricle"`
- `"left_atrium"`
- `"right_ventricle"`
- `"right_atrium"`
- `"systemic"`
- `"pulmonary"`
- `"aortic_valve"`
- `"mitral_valve"`
- `"pulmonary_valve"`
- `"tricuspid_valve"`
- `"thermal_system"`

The default values are as follows:

```python
    generic_params = {
        "nstep": 2000,          # Number of time steps.
        "period": 0.9,          # Cardiac period.
        "ncycle": 10,           # Number of cardiac cycles, only last is returned.
        "rk": 4,                # Runge-Kutta order (2 or 4).
        "rho": 1.06,            # Density of blood.
        "est_h_vol": True,      # Whether to estimate heart volume
        "height": 160,          # Height (cm)
        "weight": 80,           # Weight (kg)
        "age": 32,              # Age (years)
        "sex": 1,               # Sex (0 for male, 1 for female)
        "e_scale": 1,           # Scales all heart elastance
        "v_scale": 1,           # Scales all heart volume.
        "r_scale": 1,           # Scales all resistances.
        "c_scale": 1,           # Scales all compliances.
    }

    ecg = {
        "t1": 0,        # Time of P wave peak.
        "t2": 0.142,    # Time of R wave peak.
        "t3": 0.462,    # Time of T wave peak.
        "t4": 0.522,    # Time of end of T wave.
    }

    left_ventricle = {
        "emin": 0.1,    # Minimum elastance.
        "emax": 0.5,    # Maximum elastance.
        "vmin": 10,     # Minimum volume.
        "vmax": 135,    # Maximum volume.
    }

    left_atrium = {
        "emin": 0.15,
        "emax": 0.25,
        "vmin": 3,
        "vmax": 27,
    }

    right_ventricle = {
        "emin": 0.1,
        "emax": 0.92,
        "vmin": 55,
        "vmax": 180,
    }

    right_atrium = {
        "emin": 0.15,
        "emax": 0.25,
        "vmin": 17,
        "vmax": 40,
    }

    systemic = {
        "pini": 80,             # Initial pressure.
        "scale_R": 0.7,         # Resistance scaling term.
        "scale_C": 0.8,         # Compliance scaling term.
        "ras": 0.003,           # Aortic sinus resistance.
        "rat": 0.05,            # Artery resistance.
        "rar": 0.5,             # Arterioes resistance.
        "rcp": 0.52,            # Capillary resistance.
        "rvn": 0.075,           # Venous resistance.
        "cas": 0.008,           # Aortic sinus resistance.
        "cat": 1.6,             # Artery compliance.
        "cvn": 20.5,            # Venous compliance.
        "las": 6.2e-5,          # Aortic sinus inductance.
        "lat": 1.7e-3,          # Artery Inductance.
    }

    pulmonary = {
        "pini": 20,             # Initial pressure.
        "scale_R": 1,           # Resistance scaling term.
        "scale_C": 1,           # Compliance scaling term.
        "ras": 0.002,           # Pulmonary artery resistance.
        "rat": 0.01,            # Artery resistance.
        "rar": 0.05,            # Arterioes resistance.
        "rcp": 0.25,            # Capillary resistance.
        "rvn": 0.006,           # Venous resistance.
        "cas": 0.18,            # Pulmonary artery resistance.
        "cat": 3.8,             # Artery compliance.
        "cvn": 20.5,            # Venous compliance.
        "las": 5.2e-5,          # Pulmonary artery inductance.
        "lat": 1.7e-3,          # Artery Inductance.
    }

    aortic_valve = {
        "leff": 1,              # Effective inductance of the valve.
        "aeffmin": 1e-10,       # Minimum effective area of the valve.
        "aeffmax": 2,           # Maximum effective area of the valve.
        "kvc": 0.012,           # Valve closing paramater.
        "kvo": 0.012,           # Valve opening parameter.
    }

    mitral_valve = {
        "leff": 1,
        "aeffmin": 1e-10,
        "aeffmax": 7.7,
        "kvc": 0.03,
        "kvo": 0.04,
    }

    pulmonary_valve = {
        "leff": 1,
        "aeffmin": 1e-10,
        "aeffmax": 5,
        "kvc": 0.012,
        "kvo": 0.012,
    }

    tricuspid_valve = {
        "leff": 1,
        "aeffmin": 1e-10,
        "aeffmax": 8,
        "kvc": 0.03,
        "kvo": 0.04,
    }

    thermal_system = {
        "q_sk_basal": 6.3,      # Basal skin blood flow under neutral conditions (kg/m^2/hr)
        "k_dil": 75,            # Coefficient of vasodilation
        "t_cr": 36.8,           # Core temperature
        "t_cr_ref": 36.8,       # Core temperature under neutral conditions
        "k_con": 0.5,           # Coefficient of vasoconstriction
        "t_sk": 34.1,           # Skin temperature
        "t_sk_ref": 34.1,       # Skin temperature under neutral conditions
    }
```

module data_types

    use kind_parameter
    implicit none

    private
    public chamber, chambers
    public arterial_system, arterial_network
    public valve, valve_system
    public heart_elastance
    public thermal_system

    ! Declares the type for each chamber
    type :: chamber
        real(dp) :: Emin ! Minimum elastance
        real(dp) :: Emax ! Maximum elastance
        real(dp) :: V0_1 ! Minimum volume
        real(dp) :: V0_2 ! Maximum volume
    end type chamber

    ! Declares the type for all 4 heart chambers
    type :: chambers
        type (chamber) :: LV ! Left ventricle
        type (chamber) :: LA ! Left atrium
        type (chamber) :: RV ! Right ventricle
        type (chamber) :: RA ! Right atrium
     end type chambers

    ! Declare systemic/pulmonary system
    type :: arterial_system
        real(dp) :: Ras ! Aortic (or Pulmonary Artery) Sinus Resistance
        real(dp) :: Rat ! Artery Resistance
        real(dp) :: Rar ! Arterioles Resistance
        real(dp) :: Rcp ! Capillary Resistance
        real(dp) :: Rvn ! Vein Resistance
        real(dp) :: Cas ! Aortic Sinus (or Pulmonary Artery) Compliance
        real(dp) :: Cat ! Artery Compliance
        real(dp) :: Cvn ! Vein Compliance
        real(dp) :: Las ! Aortic Sinus (or Pulmonary Artery) Inductance
        real(dp) :: Lat ! Artery Inductance
     end type arterial_system

    ! Declares the complete network
    type :: arterial_network
        type (arterial_system) :: sys   ! Systemic system (arterial and venous)
        type (arterial_system) :: pulm  ! Pulmonary system (arterial and venous)
        real(dp) :: rho
     end type arterial_network

    ! Declares the valve type
    type :: valve
        real(dp) :: Leff    ! Effective inductance of the valve.
        real(dp) :: Aeffmin ! Minimum effective area of the valve.
        real(dp) :: Aeffmax ! Maximum effective area of the valve.
        real(dp) :: Kvc     ! Valve closing parameter
        real(dp) :: Kvo     ! Valve opening parameter
     end type valve

    ! Declares a system of valves
    type :: valve_system
        type (valve) :: AV ! Aortic
        type (valve) :: MV ! Mitral
        type (valve) :: PV ! Pulmonary
        type (valve) :: TV ! Tricuspid
     end type valve_system

    ! Declares the heart elastance type
    type :: heart_elastance
        real(dp), allocatable :: ELV(:) ! Elastance curve for the left ventricle
        real(dp), allocatable :: ELA(:) ! Elastance curve for the left atrium
        real(dp), allocatable :: ERV(:) ! Elastance curve for the right ventricle
        real(dp), allocatable :: ERA(:) ! Elastance curve for the right atrium
     end type heart_elastance

     ! Declares the system of thermal parameters
     type :: thermal_system
        real(dp) :: q_sk_basal  ! Basal skin blood flow under neutral conditions (Kg / m^2 / hr)
        real(dp) :: k_dil       ! Coefficient of vasodilation
        real(dp) :: T_cr        ! Core temperature
        real(dp) :: T_cr_ref    ! Core temperature at neutral conditions
        real(dp) :: k_con       ! Coefficient of vasoconstriction
        real(dp) :: T_sk        ! Skin temperature
        real(dp) :: T_sk_ref    ! Skin temperature at neutral condtions
     end type thermal_system

end module data_types

subroutine closed_loop_lumped(nstep, &
     T, ncycle, rk, rho, &
     lv_emin, lv_emax, lv_v01, lv_v02, &
     la_emin, la_emax, la_v01, la_v02, &
     rv_emin, rv_emax, rv_v01, rv_v02, &
     ra_emin, ra_emax, ra_v01, ra_v02, &
     est_h_vol, height, weight, age, sex, &
     pini_sys, scale_Rsys, scale_Csys, &
     sys_ras, sys_rat, sys_rar, sys_rcp, sys_rvn, &
     sys_cas, sys_cat, sys_cvn, sys_las, sys_lat, &
     pini_pulm, scale_Rpulm, scale_Cpulm, &
     pulm_ras, pulm_rat, pulm_rar, pulm_rcp, pulm_rvn, &
     pulm_cas, pulm_cat, pulm_cvn, pulm_las, pulm_lat, &
     av_leff, av_aeffmin, av_aeffmax, av_kvc, av_kvo, &
     mv_leff, mv_aeffmin, mv_aeffmax, mv_kvc, mv_kvo, &
     pv_leff, pv_aeffmin, pv_aeffmax, pv_kvc, pv_kvo, &
     tv_leff, tv_aeffmin, tv_aeffmax, tv_kvc, tv_kvo, &
     t1, t2, t3, t4, &
     q_sk_basal, k_dil, T_cr, T_cr_ref, k_con, T_sk, T_sk_ref, &
     sol_out) bind(c, name='solve_system')
  
  use iso_c_binding
  use funcs
  use data_types
  use kind_parameter

  implicit none

  integer(c_int), intent(in), value :: nstep
  integer(c_int), intent(in), value :: ncycle, rk
  real(c_double), intent(in), value :: T, pini_sys, pini_pulm, rho
  real(c_double), intent(in), value :: scale_Rsys, scale_Csys, scale_Rpulm, scale_Cpulm
  real(c_double), intent(in), value :: t1, t2, t3, t4
  real(c_double), intent(in), value :: lv_emin, lv_emax, lv_v01, lv_v02
  real(c_double), intent(in), value :: la_emin, la_emax, la_v01, la_v02
  real(c_double), intent(in), value :: rv_emin, rv_emax, rv_v01, rv_v02
  real(c_double), intent(in), value :: ra_emin, ra_emax, ra_v01, ra_v02
  logical(c_bool), intent(in), value :: est_h_vol
  real(c_double), intent(in), value :: height, weight, age, sex
  real(c_double), intent(in), value :: sys_ras, sys_rat, sys_rar, sys_rcp, sys_rvn
  real(c_double), intent(in), value :: sys_cas, sys_cat, sys_cvn, sys_las, sys_lat
  real(c_double), intent(in), value :: pulm_ras, pulm_rat, pulm_rar, pulm_rcp, pulm_rvn
  real(c_double), intent(in), value :: pulm_cas, pulm_cat, pulm_cvn, pulm_las, pulm_lat
  real(c_double), intent(in), value :: av_leff, av_aeffmin, av_aeffmax, av_kvc, av_kvo
  real(c_double), intent(in), value :: mv_leff, mv_aeffmin, mv_aeffmax, mv_kvc, mv_kvo
  real(c_double), intent(in), value :: pv_leff, pv_aeffmin, pv_aeffmax, pv_kvc, pv_kvo
  real(c_double), intent(in), value :: tv_leff, tv_aeffmin, tv_aeffmax, tv_kvc, tv_kvo
  real(c_double), intent(in), value :: q_sk_basal, k_dil, T_cr, T_cr_ref, k_con, T_sk, T_sk_ref

  type (arterial_system) :: sys, pulm
  type (chamber) :: LV, LA, RV, RA
  type (valve) :: AV, MV, PV, TV
  type (thermal_system) :: therm

  real(c_double) :: scale_Emax, scale_EmaxLV, scale_EmaxRV
  
  real(dp) :: sol(31, nstep)
  real(c_double), intent(out) :: sol_out(31, nstep)

  ! Sets E scales to be 1 - this will likely be removed soon
  ! But will wait for further model development before deciding.
  scale_Emax = real(1, c_double)
  scale_EmaxLV = real(1, c_double)
  scale_EmaxRV = real(1, c_double)

  ! Sets up heart chambers
  LV = chamber(real(lv_emin, dp), real(lv_emax, dp), real(lv_v01, dp), real(lv_v02, dp))
  LA = chamber(real(la_emin, dp), real(la_emax, dp), real(la_v01, dp), real(la_v02, dp))
  RV = chamber(real(rv_emin, dp), real(rv_emax, dp), real(rv_v01, dp), real(rv_v02, dp))
  RA = chamber(real(ra_emin, dp), real(ra_emax, dp), real(ra_v01, dp), real(ra_v02, dp))

  ! Sets up arterial systems
  sys = arterial_system(real(sys_ras, dp), real(sys_rat, dp), real(sys_rar, dp), &
       real(sys_rcp, dp), real(sys_rvn, dp), real(sys_cas, dp), real(sys_cat, dp), &
       real(sys_cvn, dp), real(sys_las, dp), real(sys_lat, dp))
  pulm = arterial_system(real(pulm_ras, dp), real(pulm_rat, dp), real(pulm_rar, dp), &
       real(pulm_rcp, dp), real(pulm_rvn, dp), real(pulm_cas, dp), real(pulm_cat, dp), &
       real(pulm_cvn, dp), real(pulm_las, dp), real(pulm_lat, dp))

  ! Sets up valves
  AV = valve(real(av_leff, dp), real(av_aeffmin, dp), real(av_aeffmax, dp), &
       real(av_kvc, dp), real(av_kvo, dp))
  MV = valve(real(mv_leff, dp), real(mv_aeffmin, dp), real(mv_aeffmax, dp), &
       real(mv_kvc, dp), real(mv_kvo, dp))
  PV = valve(real(pv_leff, dp), real(pv_aeffmin, dp), real(pv_aeffmax, dp), &
       real(pv_kvc, dp), real(pv_kvo, dp))
  TV = valve(real(tv_leff, dp), real(tv_aeffmin, dp), real(tv_aeffmax, dp), &
       real(tv_kvc, dp), real(tv_kvo, dp))

  ! Sets up thermal system
  therm = thermal_system(&
       real(q_sk_basal, dp), &
       real(k_dil, dp), real(T_cr, dp), real(T_cr_ref, dp), &
       real(k_con, dp), real(T_sk, dp), real(T_sk_ref, dp))

  ! Solves the system
  sol = solve_system(int(nstep), &
       real(T, dp), int(ncycle), int(rk), real(pini_sys, dp), real(pini_pulm, dp), &
       AV, MV, PV, TV, &
       real(scale_Rsys, dp), real(scale_Csys, dp), real(scale_Rpulm, dp), real(scale_Cpulm, dp), &
       real(rho, dp), sys, pulm, &
       real(scale_EmaxLV, dp), real(scale_EmaxRV, dp), real(scale_Emax, dp), &
       LV, LA, RV, RA, &
       logical(est_h_vol), real(height, dp), real(weight, dp), real(age, dp), real(sex, dp), &
       real(t1, dp), real(t2, dp), real(t3, dp), real(t4, dp), &
       therm)

  sol_out = real(sol, c_double)
end subroutine closed_loop_lumped

!> Numerical storage size parameters for real and integer values
module kind_parameter
   implicit none
   public

   !> Single precision real numbers, 6 digits, range 10⁻³⁷ to 10³⁷-1; 32 bits
   integer, parameter :: sp = selected_real_kind(6, 37)
   !> Double precision real numbers, 15 digits, range 10⁻³⁰⁷ to 10³⁰⁷-1; 64 bits
   integer, parameter :: dp = selected_real_kind(15, 307)
   !> Quadruple precision real numbers, 33 digits, range 10⁻⁴⁹³¹ to 10⁴⁹³¹-1; 128 bits
   integer, parameter :: qp = selected_real_kind(33, 4931)

   !> Char length for integers, range -2⁷ to 2⁷-1; 8 bits
   integer, parameter :: i1 = selected_int_kind(2)
   !> Short length for integers, range -2¹⁵ to 2¹⁵-1; 16 bits
   integer, parameter :: i2 = selected_int_kind(4)
   !> Length of default integers, range -2³¹ to 2³¹-1; 32 bits
   integer, parameter :: i4 = selected_int_kind(9)
   !> Long length for integers, range -2⁶³ to 2⁶³-1; 64 bits
   integer, parameter :: i8 = selected_int_kind(18)

end module kind_parameter

module thermoregulation
  use kind_parameter
  use data_types

contains

   pure function calc_resistance_index(&
    q_sk_basal, &
    k_dil, T_cr, T_cr_ref, &
    k_con, T_sk, T_sk_ref) result(lambda)
    ! Calculates the resistance index for the skin based on Gagge's two node model

    ! Declares variables
    real(dp), intent(in) :: q_sk_basal  ! Basal skin flow at neutral conditions
    real(dp), intent(in) :: k_dil       ! Coefficient of vasodilation
    real(dp), intent(in) :: T_cr        ! Core temperature
    real(dp), intent(in) :: T_cr_ref    ! Core temperature at neutral conditions
    real(dp), intent(in) :: k_con       ! Coefficient of vasoconstriction
    real(dp), intent(in) :: T_sk        ! Skin temperature
    real(dp), intent(in) :: T_sk_ref    ! Skin temperature at neutral condtions

    real(dp) :: wsig_cr                 ! Warm signal - core.
    real(dp) :: csig_sk                 ! Cold signal - skin.
    real(dp) :: lambda                  ! Resistance index.

    wsig_cr = max(0.0_dp, T_cr - T_cr_ref)
    csig_sk = max(0.0_dp, T_sk_ref - T_sk)

    lambda = (q_sk_basal + k_dil * wsig_cr) / (q_sk_basal * (1 + k_con * csig_sk))

  end function calc_resistance_index

  pure function calc_r_sk(r_sk, therm) result(new_r_sk)
    ! Updates the skin resistance based on Gagge's two-node thermal model.

    ! Declares variables
    real(dp), intent(in) :: r_sk                ! Skin resistance
    type (thermal_system), intent(in) :: therm  ! Thermal system coefficients

    real(dp) :: lambda                  ! Resistance index
    real(dp) :: new_r_sk                ! New skin resistance

    ! Avoids diving by 0
    if (abs(therm%q_sk_basal) > 1e-30) then
       lambda = calc_resistance_index(&
            therm%q_sk_basal, &         ! Basal Skin Blood Flow under neutral conditions
            therm%k_dil, therm%T_cr, therm%T_cr_ref, &
            therm%k_con, therm%T_sk, therm%T_sk_ref)
    else
       lambda = 1.0_dp
    end if


    new_r_sk = r_sk / lambda

  end function calc_r_sk
end module thermoregulation

module inputs
    ! Heart Input Declaration
    use kind_parameter
    use data_types
    implicit none

    private
    public heart_input, artery_input

contains

    ! Gets the heart input
    subroutine heart_input(LV, LA, RV, RA, scale_EmaxLV, scale_EmaxRV, scale_Emax)

        ! Defines initial variables
        real(dp), intent(in) :: scale_EmaxLV
        real(dp), intent(in) :: scale_EmaxRV
        real(dp), intent(in) :: scale_Emax

        type (chamber), intent(inout) :: LV
        type (chamber), intent(inout) :: LA
        type (chamber), intent(inout) :: RV
        type (chamber), intent(inout) :: RA

        ! Left Ventricle
        LV%Emax = LV%Emax * scale_EmaxLV

        ! Left Atrium
        LA%Emax = LA%Emax * scale_Emax

        ! Right Ventricle
        RV%Emax = RV%Emax * scale_EmaxRV

        ! Right Atrium
        RA%Emax = RA%Emax * scale_Emax

    end subroutine heart_input

    ! Gets the artery input
    subroutine artery_input(sys, pulm, scale_Rsys, scale_Csys, scale_Rpulm, scale_Cpulm)

        ! Declare inputs
        type (arterial_system), intent(inout) :: sys, pulm
        real(dp), intent(in) :: scale_Rsys, scale_Csys, scale_Rpulm, scale_Cpulm

        ! Systemic system
        sys%Ras = sys%Ras * scale_Rsys
        sys%Rat = sys%Rat * scale_Rsys
        sys%Rar = sys%Rar * scale_Rsys
        sys%Rcp = sys%Rcp * scale_Rsys

        sys%Cas = sys%Cas * scale_Csys
        sys%Cat = sys%Cat * scale_Csys
        sys%Cvn = sys%Cvn * scale_Csys
        
        ! Pulmonary system
        pulm%Ras = pulm%Ras * scale_Rpulm
        pulm%Rat = pulm%Rat * scale_Rpulm
        pulm%Rar = pulm%Rar * scale_Rpulm
        pulm%Rcp = pulm%Rcp * scale_Rpulm

        pulm%Cas = pulm%Cas * scale_Cpulm
        pulm%Cat = pulm%Cat * scale_Cpulm
        pulm%Cvn = pulm%Cvn * scale_Cpulm

    end subroutine artery_input
end module inputs

module funcs

    use kind_parameter
    use data_types
    use inputs
    use cust_fns
    use elastance
    use thermoregulation
    implicit none

    private
    public solver
    public solve_system

contains

    ! Solves the system
    pure function solver(sol, a_cof, v_cof, h_cof, elast, therm, k) result(ftot)

        ! Declare input variables
        real(dp), dimension(22), intent(in) :: sol
        type (arterial_network), intent(in) :: a_cof
        type (valve_system), intent(in) :: v_cof
        type (chambers), intent(in) :: h_cof
        type (heart_elastance), intent(in) :: elast
        type (thermal_system), intent(in) :: therm
        integer, intent(in) :: k

        real(dp), dimension(22) :: ftot
        real(dp) :: mmHg, resist, rho
        real(dp) :: Qav, Qsas, Qsat, Qtv, Qpv, Qpas, Qpat, Qmv, Qpvn, Qsvn
        real(dp) :: psas, psat, psvn, ppas, ppat, ppvn
        real(dp) :: Vlv, Vla, Vrv, Vra
        real(dp) :: ksi_av, ksi_mv, ksi_pv, ksi_tv
        real(dp) :: plv, pla, prv, pra
        real(dp), dimension(4) :: Aeff
        real(dp), dimension(4) :: B
        real(dp), dimension(4) :: Z
        real(dp) :: dpav, dpmv, dppv, dptv
        real(dp) :: R_scp

        ! Initialises ftot to be zero
        ftot = 0.0_dp

        mmHg = 1333.0_dp
        resist = 1.0_dp

        ! Flows
        Qav = sol(1)
        Qsas = sol(2)
        Qsat = sol(3)
        Qtv = sol(4)
        Qpv = sol(5)
        Qpas = sol(6)
        Qpat = sol(7)
        Qmv = sol(8)

        ! Pressures
        psas = sol(9)
        psat = sol(10)
        psvn = sol(11)
        ppas = sol(12)
        ppat = sol(13)
        ppvn = sol(14)

        ! Volumes
        Vlv = sol(15)
        Vla = sol(16)
        Vrv = sol(17)
        Vra = sol(18)

        ! Valves
        ksi_av = sol(19)
        ksi_mv = sol(20)
        ksi_pv = sol(21)
        ksi_tv = sol(22)

        ! Blood density
        rho = a_cof%rho

        ! Pressures in the chambers of the heart
        plv = elast%ELV(k) * (Vlv - h_cof%LV%V0_1)
        pla = elast%ELA(k) * (Vla - h_cof%LA%V0_1)
        prv = elast%ERV(k) * (VRv - h_cof%RV%V0_1)
        pra = elast%ERA(k) * (VRa - h_cof%RA%V0_1)

        ! Inductance and resistance systemic 
        ftot(2) = (psas - psat - a_cof%sys%Ras * Qsas) / a_cof%sys%Las

        ! Updates capillary resistance based on thermal model
        R_scp = calc_r_sk(a_cof%sys%Rcp, therm)
        ftot(3) = (psat - psvn - (a_cof%sys%Rat + a_cof%sys%Rar + R_scp)* Qsat) / a_cof%sys%Lat
        Qsvn = (psvn  - pra) / a_cof%sys%Rvn

        ! Inductance and resistance pulmonary
        ftot(6) = (ppas - ppat - a_cof%pulm%Ras * Qpas) / a_cof%pulm%Las 
        ftot(7) = (ppat - ppvn - (a_cof%pulm%Rat + a_cof%pulm%Rar + a_cof%pulm%Rcp)* Qpat) / a_cof%pulm%Lat
        Qpvn = (ppvn - pla) / a_cof%pulm%Rvn

        ! Compliance systemic
        ftot(9) = (Qav - Qsas) / a_cof%sys%Cas
        ftot(10) = (Qsas - Qsat) / a_cof%sys%Cat
        ftot(11) = (Qsat - Qsvn) / a_cof%sys%Cvn

        ! Compliance Pulmonary
        ftot(12) = (Qpv - Qpas) / a_cof%pulm%Cas
        ftot(13) = (Qpas - Qpat) / a_cof%pulm%Cat
        ftot(14) = (Qpat - Qpvn) / a_cof%pulm%Cvn

        ! Volume-Flow relations systemic
        ftot(15) = Qmv- Qav
        ftot(16) = Qpvn - Qmv
        ftot(17) = Qtv - Qpv
        ftot(18) = Qsvn - Qtv

        !!! Aortic Valve !!!
        ! Effective area of the valve
        Aeff(1) = (v_cof%AV%Aeffmax - v_cof%AV%Aeffmin) * ksi_av + v_cof%AV%Aeffmin
        ! Bernoulli resistance of the valve
        B(1) = rho / (2 * Aeff(1) ** 2) * resist
        ! Impedance of the valve
        Z(1) = rho * v_cof%AV%Leff/Aeff(1)

        ! Pressure-flow relations through valve
        dpav = (plv - psas) * mmHg
        ftot(1) = (dpav - B(1) * Qav * abs(Qav))/ Z(1)

        if (dpav <= 0) then ! Valve closing
            ftot(19) = ksi_av * v_cof%AV%Kvc * dpav 
        else ! Valve opening
            ftot(19) = (1 - ksi_av) * v_cof%AV%Kvo * dpav
        end if

        !!! Mitral Valve !!!
        Aeff(2) = (v_cof%MV%Aeffmax - v_cof%MV%Aeffmin) * ksi_mv + v_cof%MV%Aeffmin
        B(2) = rho / (2 * Aeff(2) ** 2) * resist
        Z(2) = rho * v_cof%MV%Leff / Aeff(2)

        ! Pressure-flow relations through valve
        dpmv = (pla-plv)*mmHg
        ftot(8) = (dpmv-B(2)*Qmv*abs(Qmv) )/Z(2)

        if (dpmv <= 0)  then ! Valve closing
            ftot(20) = ksi_mv*v_cof%MV%Kvc*dpmv
        else  ! Valve opening
            ftot(20) = (1-ksi_mv)*v_cof%MV%Kvo*dpmv
        end if


        !!! Pulmonary Valve !!!
        Aeff(3) = (v_cof%PV%Aeffmax-v_cof%PV%Aeffmin)*ksi_pv + v_cof%PV%Aeffmin
        B(3) = rho/(2 * Aeff(3) ** 2)*resist
        Z(3) = rho*v_cof%PV%Leff/Aeff(3)

        ! pressure-flow relations through valve
        dppv = (prv-ppas)*mmHg
        ftot(5) = (dppv-B(3)*Qpv*abs(Qpv) )/Z(3)   ! Qpv

        if (dppv <= 0)  then !valve closing
            ftot(21) = ksi_pv*v_cof%PV%Kvc*dppv
        else ! valve opening
            ftot(21) = (1-ksi_pv)*v_cof%PV%Kvo*dppv  ! ksi_pv
        end if

        !!! Tricuspic Valve !!!
        Aeff(4) = (v_cof%TV%Aeffmax-v_cof%TV%Aeffmin)*ksi_tv + v_cof%TV%Aeffmin
        B(4) = rho/(2*Aeff(4)**2)*resist
        Z(4) = rho*v_cof%MV%Leff/Aeff(4)

        ! pressure-flow relations through valve
        dptv = (pra-prv)*mmHg
        ftot(4) = (dptv-B(4)*Qtv*abs(Qtv) )/Z(4)   !Qtv

        if (dptv <= 0)  then ! Valve closing
            ftot(22) = ksi_tv*v_cof%TV%Kvc*dptv
        else ! Valve opening
            ftot(22) = (1-ksi_tv)*v_cof%TV%Kvo*dptv      !ksi_tv
        end if
    end function solver

    function solve_system(&
         nstep, &
         T, &
         ncycle, &
         rk, &
         pini_sys, &
         pini_pulm, &
         AV, &
         MV, &
         PV, &
         TV, &
         scale_Rsys_in, &
         scale_Csys_in, &
         scale_Rpulm_in, &
         scale_Cpulm_in, &
         rho, &
         sys_in, &
         pulm_in, &
         scale_EmaxLV, &
         scale_EmaxRV, &
         scale_Emax, &
         LV_in, &
         LA_in, &
         RV_in, &
         RA_in, &
         estimate_vol, &
         height, &
         weight, &
         age, &
         sex, &
         t1, &
         t2, &
         t3, &
         t4, &
         therm) result (soln_all)
         
      ! Declares input variables
      integer, intent(in) :: nstep, ncycle, rk
      real(dp), intent(in) :: T, pini_sys, pini_pulm, rho
      real(dp), intent(in) :: scale_Rsys_in, scale_Csys_in, scale_Rpulm_in, scale_Cpulm_in
      real(dp), intent(in) :: scale_Emax, scale_EmaxLV, scale_EmaxRV
      real(dp), intent(in) :: t1, t2, t3, t4
      type (arterial_system), intent(in) :: sys_in, pulm_in
      type (chamber), intent(in) :: LV_in, LA_in, RV_in, RA_in
      logical, intent(in) :: estimate_vol
      real(dp), intent(in) :: height, weight, age, sex
      type (thermal_system), intent(in) :: therm

      ! Declare temp variables
      integer :: i, icycle, k, offset
      real(dp) :: h, t_val
      real(dp) :: scale_Rsys, scale_Csys, scale_Rpulm, scale_Cpulm
      type (chamber) :: LV, LA, RV, RA
      type (arterial_system) :: sys, pulm
      type (arterial_network) :: a_cof
      type (chambers) :: h_cof
      type (valve) :: AV, MV, PV, TV
      type (valve_system) :: v_cof
      real(dp), allocatable, dimension(:) :: ELV, ELA, ERV, ERA
      type (heart_elastance) :: elast, elast_half
      real(dp) :: current_sol(22)
      real(dp), allocatable :: h_pres(:, :) 
      real(dp), allocatable :: t_axis(:)
      real(dp), dimension(22) :: k1, k2, k3, k4
      real(dp), allocatable :: sol(:, :)

      ! Declare output variables
      real(dp), allocatable :: soln_all(:, :)


      !!! Initialisation !!!

      ! Relevant arterial coefficients
      sys = sys_in
      pulm = pulm_in
      scale_Rsys = scale_Rsys_in
      scale_Csys = scale_Csys_in
      scale_Rpulm = scale_Rpulm_in
      scale_Cpulm = scale_Cpulm_in
      call artery_input(sys, pulm, scale_Rsys, scale_Csys, scale_Rpulm, scale_Cpulm)
      a_cof = arterial_network(sys, pulm, rho)

      ! Relevant heart coefficients
      LV = LV_in
      LA = LA_in
      RV = RV_in
      RA = RA_in
      call heart_input(LV, LA, RV, RA, scale_EmaxLV, scale_EmaxRV, scale_Emax)
      h_cof = chambers(LV, LA, RV, RA)

      ! If estimate_vol, uses height, weight, age and sex to estimate heart volume
      if ( estimate_vol ) then
         call update_heart_vol(h_cof, height, weight, age, sex)
      end if

      ! Relevant valve coefficients
      v_cof = valve_system(AV, MV, PV, TV)

      !!! Main code !!!

      ! Calculates elastance curves for the different chambers of the heart
      allocate(t_axis(nstep))
      h = T / real(nstep, dp)
      t_val = 0.0_dp
      do i = 1, nstep
         t_axis(i) = t_val
         t_val = t_val + h
      end do
      allocate(ELV(nstep))
      allocate(ELA(nstep))
      allocate(ERV(nstep))
      allocate(ERA(nstep))
      ! t1 is the time of the P peak
      ! t2 is the time of the R peak
      ! t3 is the time of the T peak
      ! t4 is the time of the end of the T wave (also called T offset)
      ELV = calc_elastance(h_cof%LV, t_axis, t1, t2, t3, t4, is_atria=.false.)
      ELA = calc_elastance(h_cof%LA, t_axis, t1, t2, t3, t4, is_atria=.true.)
      ERV = calc_elastance(h_cof%RV, t_axis, t1, t2, t3, t4, is_atria=.false.)
      ERA = calc_elastance(h_cof%RA, t_axis, t1, t2, t3, t4, is_atria=.true.)

      ! Saves the heart information at the points
      elast = heart_elastance(ELV=ELV, ELA=ELA, ERV=ERV, ERA=ERA)
      elast_half = heart_elastance(ELV=midpoint(ELV), &
           ELA=midpoint(ELA), &
           ERV=midpoint(ERV), &
           ERA=midpoint(ERA))

      ! Initialise the solution
      allocate(sol(22, ncycle * nstep + 1))

      sol(1, 1) = 0.0_dp   ! Flow through aortic valve
      sol(2, 1) = 0.0_dp   ! Flow through sinus
      sol(3, 1) = 0.0_dp   ! Flow through aorta
      sol(4, 1) = 0.0_dp   ! Flow through tricuspid
      sol(5, 1) = 0.0_dp   ! Flow through pulmonary
      sol(6, 1) = 0.0_dp   ! Flow through arteries
      sol(7, 1) = 0.0_dp   ! Flow through arterioles
      sol(8, 1) = 0.0_dp   ! Flow through mitral valve

      sol(9, 1) = pini_sys    ! Initial arterial pressure
      sol(10, 1) = pini_sys    ! Initial arterial pressure
      sol(11, 1) = pini_sys    ! Initial arterial pressure
      sol(12, 1) = pini_pulm    ! Initial pulmonary pressure
      sol(13, 1) = pini_pulm    ! Initial pulmonary pressure
      sol(14, 1) = pini_pulm    ! Initial pulmonary pressure

      sol(15, 1) = h_cof%LV%v0_2    ! End diastolic left ventricular volume
      sol(16, 1) = h_cof%LA%v0_2    ! End diastolic left atrial volume
      sol(17, 1) = h_cof%RV%v0_2    ! End diastolic right ventricular volume
      sol(18, 1) = h_cof%RA%v0_2    ! End diastolic right atrial volume

      sol(19, 1) = 0.0_dp  ! Aortic valve is initially closed.
      sol(20, 1) = 0.0_dp  ! Mitral valve is initially closed.
      sol(21, 1) = 0.0_dp  ! Pulmonary valve is initially closed.
      sol(22, 1) = 0.0_dp  ! Tricuspid valve is initially closed.

      ! Solves the system of equations using a 4th order Runge-Kutta method
      i = 0 ! Initialise

      do icycle = 1, ncycle
         do k = 1, nstep
            i = i + 1
            current_sol = sol(:, i)
            if (rk == 2) then ! Second order Runge-Kutta
               k1 = h * solver(current_sol, a_cof, v_cof, h_cof, elast, therm, k)
               k2 = h * solver(current_sol + k1/2, a_cof, v_cof, h_cof, elast, therm, k)
               sol(:, i+1) = current_sol + k2
            else if (rk == 4) then ! Fourth order Runge-Kutta
               k1 = h * solver(current_sol, a_cof, v_cof, h_cof, elast, therm, k)
               k2 = h * solver(current_sol + k1/2, a_cof, v_cof, h_cof, elast, therm, k)
               k3 = h * solver(current_sol + k2/2, a_cof, v_cof, h_cof, elast, therm, k)
               if ( k /= nstep ) then
                  k4 = h * solver(current_sol + k3, a_cof, v_cof, h_cof, elast, therm, k+1)
               else
                  k4 = h * solver(current_sol + k3, a_cof, v_cof, h_cof, elast, therm, 1)
               end if
               sol(:, i + 1) = current_sol + (k1 + 2 * k2 + 2 * k3 + k4) / 6
            end if
         end do
      end do

      ! Calculates ventricular pressures
      allocate(h_pres(4, nstep))
      offset = (ncycle - 1) * nstep + 2
      h_pres(1, :) = ELV * (sol(15, offset:) - LV%v0_1)
      h_pres(2, :) = ELA * (sol(16, offset:) - LA%v0_1)
      h_pres(3, :) = ERV * (sol(17, offset:) - RV%v0_1)
      h_pres(4, :) = ERA * (sol(18, offset:) - RA%v0_1)

      ! Combines all the parameters
      allocate(soln_all(31, nstep))
      soln_all(1:22, :) = sol(:, offset:)
      soln_all(23:26, :) = h_pres
      soln_all(27, :) = ELV
      soln_all(28, :) = ELA
      soln_all(29, :) = ERV
      soln_all(30, :) = ERA
      soln_all(31, :) = t_axis

    end function solve_system
end module funcs

module elastance

    use kind_parameter
    use data_types
    implicit none

    private
    public calc_elastance
    public update_heart_vol

contains

    ! Atria elastance activation functions taken from:
    ! J. D. Thomas, J. Zhou, N. Greenberg, G. Bibawy, P. M. McCarthy, and P. M. Vandervoort, 
    ! “Physical and physiological determinants of pulmonary venous flow: Numerical analysis,” 
    ! Amer. J. Physiol. Heart Circ. Physiol., vol. 272, no. 5, pp. H2453–H2465, 1997.
    elemental function atria_act(t, T1, T2) result(u_a)
      real(dp), intent(in) :: t
      real(dp), intent(in) :: T1
      real(dp), intent(in) :: T2
      real(dp) :: u_a
      real(dp), parameter :: pi=4.D0*datan(1.D0)

      if ( (T1 <= t) .and. (t <= T2) ) then
         u_a = 0.5 * (1 - cos((2*pi*(t - T1))/(T2 - T1)))
      else
         u_a = 0
      end if
    end function atria_act

    ! Ventricle elastance activation functions taken from:
    ! D. C. Chung, S. C. Niranjan, J. W. Clark, A. Bidani, W. E. Johnston, J. B. Zwischenberger, and D. L. Traber, 
    ! “A dynamic model of ventricular interaction and pericardial influence,”
    ! Amer. J. Physiol. Heart Circ. Physiol., vol. 272, no. 6, pp. H2942–H2962, Jun. 1, 1997.
    elemental function ventricle_act(t, T2, T3, T4) result(u_v)
      real(dp), intent(in) :: t
      real(dp), intent(in) :: T2
      real(dp), intent(in) :: T3
      real(dp), intent(in) :: T4
      real(dp) :: u_v
      real(dp), parameter :: pi=4.D0*datan(1.D0)

      if ( (T2 <= t) .and. (t < T3) ) then
         u_v = 0.5 * (1 - cos((pi*(t - T2))/(T3 - T2)))
      else if ( (T3 <= t) .and. (t <= T4) ) then
         u_v = 0.5 * (1 + cos((pi*(t - T3))/(T4 - T3)))
      else
         u_v = 0
      end if

    end function ventricle_act

    ! Calculates the elastance of the heart
    elemental function calc_elastance(cham, t, T1, T2, T3, T4, is_atria) result(E_out)

        ! Declares input variables
        type(chamber), intent(in) :: cham
        real(dp), intent(in) :: T1
        real(dp), intent(in) :: T2
        real(dp), intent(in) :: T3
        real(dp), intent(in) :: T4
        real(dp), intent(in) :: t
        logical, intent(in) :: is_atria

        ! Declares output variable
        real(dp) :: E_out

        if (is_atria) then
           E_out = cham%Emin + (cham%Emax - cham%Emin) * atria_act(t, T1, T2)
        else
           E_out = cham%Emin + (cham%Emax - cham%Emin) * ventricle_act(t, T2, T3, T4)
        end if
    end function calc_elastance

    
    ! Heart volume calculations taken from:
    ! "Size matters! Impact of age, sex, height, and weight on the normal heart size"
    ! by Pfaffenberger, Stefan and Bartko, Philipp and Graf, Alexandra and Pernicka, Elisabeth 
    ! and Babayev, Jamil and Lolic, Emina and Bonderman, Diana and Baumgartner, Helmut 
    ! and Maurer, Gerald and Mascherbauer, Julia
    ! Journal: Circulation: Cardiovascular Imaging
    ! Year: 2013
    ! DOI: https://doi.org/10.1161/CIRCIMAGING.113.000690
    subroutine update_heart_vol(heart, height_in, weight_in, age_in, sex_in)
      ! Calculates the heart volume based of height, weight age and sex
      ! The units for each variable are as follows
      ! 
      ! | Variable | Unit  |
      ! |----------|-------|
      ! | Height   | cm    |
      ! | Weight   | kg    |
      ! | Age      | Years |
      ! 
      ! Sex is 0 for a male and 1 for a female.
      ! 
      ! Limitations taken from the study:
      !
      ! > Our data have been collected in a single center in central Europe,
      ! > thus the ethnic background of our study population was mainly
      ! > whites.  No Asian or black individuals were studied. Thus,
      ! > conclusions concerning other ethnic populations are limited.
      ! 
      ! Additionally, the paper did not discuss trans or non-binary people so this is
      ! another limitation of the study.
      ! 
      ! Conculusions taken from the study:
      !
      ! > The present work shows that sex, age, and body size affect the
      ! > normal heart size.  These parameters need to be considered when
      ! > cutoff values indicating the need for treatment or even surgery are
      ! > applied.

      type(chambers), intent(inout) :: heart
      real(dp), intent(in) :: height_in    ! Height (cm)
      real(dp), intent(in) :: weight_in    ! Weight (kg)
      real(dp), intent(in) :: age_in       ! Age (Years)
      real(dp), intent(in) :: sex_in       ! Sex (0 for male, 1 for female)
      real(dp) :: height, weight, age, sex

      ! i = intecept, w = weight, h = height, s = sex
      ! Paper did not have data for right ventricle.
      real(dp) :: lv_i, lv_w, lv_h, lv_a, lv_s    ! Left Ventricle
      real(dp) :: la_i, la_w, la_h, la_a          ! Left Atrium
      real(dp) :: ra_i, ra_w, ra_s                ! Right atrium

      real(dp) :: lv_vol, la_vol, ra_vol
      real(dp) :: lv_scale, la_scale, ra_scale, rv_scale

      !!!!!!!!!!!!!!!!!!!!!
      !!! Checks inputs !!!
      !!!!!!!!!!!!!!!!!!!!!

      if ( (abs(sex_in) >= 1e-5_dp) .and. (abs(sex_in - 1.0_dp) >= 1e-5_dp) ) then
         print *,"Sex is not 0 (male) or 1 (female). Setting to 1."
         sex = 1.0_dp
      else
         sex = sex_in
      end if

      if ( height_in <= 0.0_dp) then
         print *,"Height cannot be less than 0, setting to 160cm"
         height = 160.0_dp
      else
         height = height_in
      end if

      if ( weight_in <= 0.0_dp) then
         print *,"Weight cannot be less than 0, setting to 80kg"
         weight = 80.0_dp
      else
         weight = weight_in
      end if

      if ( age_in <= 18.0_dp ) then
         print *,"This calculation is not supported for children, setting to 18 years old"
         age = 18.0_dp
      else
         age = age_in
      end if

      !!!!!!!!!!!!!!!!!!!!!!!!!!!
      ! Calculates heart volume !
      !!!!!!!!!!!!!!!!!!!!!!!!!!!

      lv_i = -39.37731_dp
      lv_w = 0.42808_dp
      lv_h = 0.73703_dp
      lv_s = -9.47838_dp
      lv_a = -0.33895_dp
      la_i = -34.73810_dp
      la_w = 0.21533_dp
      la_h = 0.31554_dp
      la_a = 0.10538_dp
      ra_i = 18.97912_dp
      ra_w = 0.27999_dp
      ra_s = -8.55635_dp

      lv_vol = lv_i + lv_w * weight + lv_h * height + lv_s * sex + lv_a * age
      la_vol = la_i + la_w * weight + la_h * height + la_a * age
      ra_vol = ra_i + ra_w * weight + ra_s * sex

      lv_scale = lv_vol / heart%LV%V0_2
      la_scale = la_vol / heart%LA%V0_2
      ra_scale = ra_vol / heart%RA%V0_2
      rv_scale = (lv_scale + la_scale + ra_scale) / 3

      heart%LV%V0_2 = lv_vol
      heart%LV%V0_1 = heart%LV%V0_1 * lv_scale

      heart%LA%V0_2 = la_vol
      heart%LA%V0_1 = heart%LA%V0_1 * la_scale

      heart%RA%V0_2 = ra_vol
      heart%RA%V0_1 = heart%RA%V0_1 * ra_scale

      heart%RV%V0_2 = heart%RV%V0_2 * rv_scale
      heart%RV%V0_1 = heart%RV%V0_1 * rv_scale

    end subroutine update_heart_vol

end module elastance

module cust_fns

    use kind_parameter
    implicit none

    private
    public midpoint

contains

    pure function midpoint(x) result(mp)

        ! Declares initial variables
        real(dp), allocatable, intent(in) :: x(:)
        integer :: i
        real(dp) :: dx(size(x) - 1)
        real(dp) :: mp(size(x) - 1)

        do i = 1, size(dx)
            dx(i) = x(i + 1) - x(i)
        end do
        mp = x(1:size(x)-1) + dx / 2
    end function midpoint
end module cust_fns
